using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Authorization;

using DomainResults.Mvc;

using WeatherForecast.Services;

namespace WeatherForecast.Controllers;

/// <summary>
/// 
/// </summary>
[Authorize]
[ApiController]
[Route("api/[controller]")]
public class ShopItemsController : ControllerBase {

  private readonly IShopItemsService _shopItemsService;

  /// <summary>
  /// 
  /// </summary>
  /// <param name="shopCatalogService"></param>
  public ShopItemsController(
    IShopItemsService shopCatalogService
  ) {
    _shopItemsService = shopCatalogService;
  }

  /// <summary>
  /// 
  /// </summary>
  /// <param name="siteId"></param>
  /// <param name="category"></param>
  /// <param name="currentPage"></param>
  /// <param name="itemsPerPage"></param>
  /// <param name="locale"></param>
  /// <param name="searchText"></param>
  /// <returns></returns>
  [HttpGet("{siteId}")]
  public IActionResult Get([FromRoute] Guid siteId, [FromQuery] Guid? category, [FromQuery] int? currentPage, [FromQuery] int? itemsPerPage, [FromQuery] string? locale, [FromQuery] string? searchText) {
    var result = _shopItemsService.Get(siteId, category, currentPage ?? 1, itemsPerPage ?? 8, locale, searchText);
    return result.ToActionResult();
  }

  /// <summary>
  /// 
  /// </summary>
  /// <param name="siteId"></param>
  /// <returns></returns>
  [HttpDelete("{siteId}")]
  public IActionResult Delete([FromRoute] Guid siteId) {
    var result = _shopItemsService.Delete(siteId);
    return result.ToActionResult();
  }
}
